; pB.2 ... ENTER
; pB.3 ... INC
; pB.4 ... DEC
; pB.5 ... ESC
.device ATmega8
.include "m8def.inc" 
.equ				Enter = 5
.equ				incre = 4
.equ				decre = 3
.equ				Esc   = 2
.equ				frek = 2498712355
.equ				caskalibr = 24265
.equ				waitnokeymax = 2					;kolik 5ms musi cekat na nestisk klavesy
.dseg
c1000000000:		.byte	1
c100000000:			.byte	1
c10000000:			.byte	1
c1000000:			.byte	1
c100000:			.byte	1
c10000:				.byte	1
c1000:				.byte	1
c100:				.byte	1
c10:				.byte	1
c1:					.byte	1
; Frekvence pro AD9835 FREQ4:FREQ1
freq1:				.byte	1
freq2:				.byte	1
freq3:				.byte	1
freq4:				.byte	1
; Frekvence1 FREQ14:FREQ11
freq11:				.byte	1
freq12:				.byte	1
freq13:				.byte	1
freq14:				.byte	1
; Frekvence2 FREQ24:FREQ21
freq21:				.byte	1
freq22:				.byte	1
freq23:				.byte	1
freq24:				.byte	1
; Frekvence3 FREQ34:FREQ31
freq31:				.byte	1
freq32:				.byte	1
freq33:				.byte	1
freq34:				.byte	1
; cas TIME1
time2:				.byte	1
time1:				.byte	1
; cislo pro AD9835 AD4:AD1
ad1:				.byte	1
ad2:				.byte	1
ad3:				.byte	1
ad4:				.byte	1
; pomocne pro vypocet cisla z frekvence
f1:					.byte	1
f2:					.byte	1
f3:					.byte	1
f4:					.byte	1
f5:					.byte	1
f6:					.byte	1
f7:					.byte	1
ff1:				.byte	1
ff2:				.byte	1
ff3:				.byte	1
ff4:				.byte	1
ff5:				.byte	1
ff6:				.byte	1
ff7:				.byte	1
; po 0.010sec se pricita do ms2:ms1
ms2:				.byte	1
ms1:				.byte	1
; po 0.005sec se pricita
ms_temp:			.byte	1
; hodnota 00111100 kde 1 je klavesa
keyb:				.byte	1
;pomocna pro klavesnici 
keyb_temp:			.byte	1
;autorepeat pro klavesnici
keyb_repeat:		.byte	1
keyb_repeat_temp:	.byte	1
;00 = DDS , $FF = SWEEP
menus:				.byte	1
;00 = STOP $FF = START
menus1:				.byte	1
; 1= mHz, 2=Hz, 3=kHz, 4=MHz
hz:					.byte	1
; doba po kterou musi byt nestisknuta klavesa
waitnokey:			.byte	1
keyb_speed:			.byte	1
; Startovani zobrazovani sweeping
start:				.byte	1

.cseg												;PROGRAM
.org 0

			rjmp 	reset
.org $8
			jmp		timer1overflow					;preteceni casu
			
reset:		
			ldi		r16,0b00011111					;zakaz Watchdogu
			out		wdtcr,r16
			ldi		r16,0b00010111
			out		wdtcr,r16
           	ldi 	R16,low(RAMEND)					;nastaveni LOW byte adresy RAM
	        out		SPL,R16							;Inicializace SPL
	        ldi 	R16,high(RAMEND)				;nastaveni HIGH byte adresy RAM
	        out 	SPH, R16						;Inicializace SPH
; *************************************************
			clr		r16
			sts		menus1,r16
			sts		menus,r16
			sts		start,r16
; *************************************************
; nastaveni pomocne promenne na nestisknutou klavesu
			ldi		r16,0b00111100
			sts		keyb_temp,r16
			sts		keyb,r16
; *************************************************
;nastaveni PORTU jako IN/OUT a Pullup odporu
			ldi		r16,0b11111111					;nastaveni portu B s pullup rezistory
			out		portb,r16	
			ldi		r16,0b11111111					
			out		portc,r16						;nastaveni portu C s pullup rezistory
			out		portd,r16						;nastaveni portu D s pullup rezistory
			ldi		r16,0b00111111					;nastaveni portu C jako vystupy
			out		ddrc,r16
			ldi		r16,0b00011100
			out		ddrd,r16
			ldi		r16,0b00000000
			out		ddrb,r16
; *************************************************
;nastaveni TIMERu 1 + povoleni preruseni
			ldi		r16,0b00000001 					;preddelicka pro TIMER1
			out		tccr1b,r16
			ldi		r16,0b00000100
			out		timsk,r16
			sei

; *************************************************
; konstanta pro deleni na vypocet cisla pro AD9835
; ma byt 50MHz, ale pocita se s dvemi des.cisly
; 50.000.000.00 / 2^32 = 19531250 / 2^24
			clr		r16
			sts		ff1,r16
			sts		ff2,r16
			sts		ff3,r16
			ldi		r16,$1
			sts		ff4,r16
			ldi		r16,$2a
			sts		ff5,r16
			ldi		r16,$05
			sts		ff6,r16
			ldi		r16,$F2
			sts		ff7,r16
;**************************************************


; *************************************************
;UVODni obrazovka a INIcializace LCD
			call	lcdinit
			call	lcd_posup
			ldi		ZH,high(2*t_home1)				
			ldi		ZL,low(2*t_home1)	
			call	lcd_text
			call	lcd_posdown
			ldi		ZH,high(2*t_home2)				
			ldi		ZL,low(2*t_home2)	
			call	lcd_text
; *************************************************
			call	freq_none			;nebezi zadna frekvence
			call	spi_freq

aaa:
			ldi		r16,low(1000)
			sts		freq1,r16
			ldi		r16,high(1000)
			sts		freq2,r16
			ldi		r16,byte3(1000)
			sts		freq3,r16
			ldi		r16,byte4(1000)
			sts		freq4,r16
				
			call	freq_convert
			call	spi_freq

; z uvodni obrazovky se dostanu jen Enter nebo ESC
uvod:
			lds		r16,keyb
			sbrs	r16,esc				;ESC
			rjmp	menu
			sbrs	r16,enter			;ENTER
			rjmp	menu
			rjmp	uvod

; *************************************************
; MENU vyber bud DDS nebo SWEEPING
menu:
			clr		r16
			sts		menus1,r16
			sts		menus,r16
			sts		start,r16
			call	waitnokeyp
			call	freq_none			;nebezi zadna frekvence
			call	spi_freq
			rjmp	menu_lcd_dds
menu1:
			lds		r16,keyb
			cpi		r16,0b00100100		;INC + DEC
			breq	menu1
			sbrs	r16,decre			;DEC
			rjmp	menu_lcd_dds		
			sbrs	r16,incre			;INC
			rjmp	menu_lcd_sweep
			sbrs	r16,enter			;ENTER
			rjmp	menu_choose
			rjmp	menu1
; *************************************************
; co jsem si vybral a podle toho pokracovani
menu_choose:
			lds		r16,menus
			sbrs	r16,0
			rjmp	menu_dds			;byl vyber DDS
			rjmp	menu_sweep			;byl vyber SWEEP
; *************************************************
; LCD zobrazi DDS
menu_lcd_dds:
			call	lcd_posup
			ldi		ZH,high(2*t_freq_const)				
			ldi		ZL,low(2*t_freq_const)	
			call	lcd_text
			call	lcd_down_freq
			clr		r16
			sts		menus,r16
			rjmp	menu1
; *************************************************
; LCD zobrazi SWEEPING
menu_lcd_sweep:
			call	lcd_posup
			ldi		ZH,high(2*t_freq_sweep)				
			ldi		ZL,low(2*t_freq_sweep)	
			call	lcd_text
			call	lcd_down_freq
			ldi		r16,$FF
			sts		menus,r16
			rjmp	menu1
; *************************************************
; Menu pro DDS
menu_dds:
;vymaz frekvence 1
			call	spi_ini
			clr		r16
			sts		freq4,r16
			sts		freq3,r16
			sts		freq2,r16
			sts		freq1,r16
			ldi		r16,1
			sts		hz,r16
;zobrazeni frekvence 
menu_dds_2:
			call	lcd_posup
			call	lcd_freq
;test klavesnice 
menu_dds_1:																	
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_dds_hz
			sbrs	r16,incre			;INC
			rjmp	menu_dds_inc
			sbrs	r16,decre			;DEC
			rjmp	menu_dds_dec
			sbrs	r16,esc				;ESC
			rjmp	menu		
			rjmp	menu_dds_1
;zmena z mHz na Hz na kHz MHz
menu_dds_hz:
			lds		r16,hz
			inc		r16
			cpi		r16,5
			brmi	menu_dds_hz1
			ldi		r16,1
menu_dds_hz1:
			sts		hz,r16
			call	waitnokeyp
			rjmp	menu_dds_2
; pricitani frekvence
menu_dds_inc:
			call	incdec_konst
			call	freq_inc
menu_dds_common:
			ldi		r16,0b00111100
			sts		keyb,r16
			call	freq_convert
			call	spi_freq
			rjmp	menu_dds_2
;odecitani frekvence
menu_dds_dec:
			call	incdec_konst
			call	freq_dec
			rjmp	menu_dds_common
; *************************************************
; Menu pro SWEEPING
;menu pro START frekvenci
menu_sweep:
;vymaz frekvence 
			call	spi_ini
			clr		r16
			sts		freq4,r16
			sts		freq3,r16
			sts		freq2,r16
			sts		freq1,r16
menu_sweep_after:
			call	waitnokeyp
			ldi		r16,1
			sts		hz,r16
;zobrazeni frekvence 
menu_sweep_2:
			call	lcd_posup
			call	lcd_freq
			call	lcd_posdown
			ldi		r16,$46
			call	lcd_char
			ldi		r16,$6C
			call	lcd_char
			ldi		r16,$6F
			call	lcd_char
;test klavesnice 
menu_sweep_1:																	
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_sweep_hz
			sbrs	r16,enter			;Enter
			rjmp	menu_sweep2
			sbrs	r16,incre			;INC
			rjmp	menu_sweep_inc
			sbrs	r16,decre			;DEC
			rjmp	menu_sweep_dec
			sbrs	r16,esc				;ESC
			rjmp	menu		
			rjmp	menu_sweep_1
;zmena z mHz na Hz na kHz MHz
menu_sweep_hz:
			lds		r16,hz
			inc		r16
			cpi		r16,5
			brmi	menu_sweep_hz1
			ldi		r16,1
menu_sweep_hz1:
			sts		hz,r16
			call	waitnokeyp
			rjmp	menu_sweep_2
; pricitani frekvence
menu_sweep_inc:
			call	incdec_konst
			call	freq_inc
menu_sweep_common:
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	menu_sweep_2
;odecitani frekvence
menu_sweep_dec:
			call	incdec_konst
			call	freq_dec
			rjmp	menu_sweep_common

;menu pro STOP frekvenci
menu_sweep2:
;vymaz frekvence 
			call	freq_freq1
menu_sweep2_after:
			call	waitnokeyp
			ldi		r16,1
			sts		hz,r16
;zobrazeni frekvence 
menu_sweep2_2:
			call	lcd_posup
			call	lcd_freq
			call	lcd_posdown
			ldi		r16,$46
			call	lcd_char
			ldi		r16,$68
			call	lcd_char
			ldi		r16,$69
			call	lcd_char
;test klavesnice 
menu_sweep2_1:																	
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_sweep2_hz
			sbrs	r16,enter			;Enter
			rjmp	menu_sweep3
			sbrs	r16,incre			;INC
			rjmp	menu_sweep2_inc
			sbrs	r16,decre			;DEC
			rjmp	menu_sweep2_dec
			sbrs	r16,esc				;ESC
			rjmp	menu_sweep2_end		
			rjmp	menu_sweep2_1
menu_sweep2_end:
			call	freq1_freq
			rjmp	menu_sweep_after
;zmena z mHz na Hz na kHz MHz
menu_sweep2_hz:
			lds		r16,hz
			inc		r16
			cpi		r16,5
			brmi	menu_sweep2_hz1
			ldi		r16,1
menu_sweep2_hz1:
			sts		hz,r16
			call	waitnokeyp
			rjmp	menu_sweep2_2
; pricitani frekvence
menu_sweep2_inc:
			call	incdec_konst
			call	freq_inc
menu_sweep2_common:
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	menu_sweep2_2
;odecitani frekvence
menu_sweep2_dec:
			call	incdec_konst
			call	freq_dec
			rjmp	menu_sweep2_common



;menu pro STEP frekvenci
menu_sweep3:
;vymaz frekvence 
			call	freq_freq2
			clr		r16
			sts		freq4,r16
			sts		freq3,r16
			sts		freq2,r16
			sts		freq1,r16
menu_sweep3_after:
			call	waitnokeyp
			ldi		r16,1
			sts		hz,r16
;zobrazeni frekvence 
menu_sweep3_2:
			call	lcd_posup
			call	lcd_freq
			call	lcd_posdown
			ldi		r16,$46
			call	lcd_char
			ldi		r16,$73
			call	lcd_char
			ldi		r16,$74
			call	lcd_char
;test klavesnice 
menu_sweep3_1:																	
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_sweep3_hz
			sbrs	r16,enter			;Enter
			rjmp	menu_sweep4
			sbrs	r16,incre			;INC
			rjmp	menu_sweep3_inc
			sbrs	r16,decre			;DEC
			rjmp	menu_sweep3_dec
			sbrs	r16,esc				;ESC
			rjmp	menu_sweep3_end		
			rjmp	menu_sweep3_1
menu_sweep3_end:
			call	freq2_freq
			rjmp	menu_sweep2_after
;zmena z mHz na Hz na kHz MHz
menu_sweep3_hz:
			lds		r16,hz
			inc		r16
			cpi		r16,5
			brmi	menu_sweep3_hz1
			ldi		r16,1
menu_sweep3_hz1:
			sts		hz,r16
			call	waitnokeyp
			rjmp	menu_sweep3_2
; pricitani frekvence
menu_sweep3_inc:
			call	incdec_konst
			call	freq_inc
menu_sweep3_common:
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	menu_sweep3_2
;odecitani frekvence
menu_sweep3_dec:
			call	incdec_konst
			call	freq_dec
			rjmp	menu_sweep3_common

;menu pro STEP frekvenci
menu_sweep4:
;vymaz frekvence 
			call	freq_freq3
			ldi		r16,1
			sts		time1,r16
			clr		r16
			sts		time2,r16
menu_sweep4_after:
			call	waitnokeyp
			ldi		r16,1
			sts		hz,r16
;zobrazeni frekvence 
menu_sweep4_2:
			call	lcd_posup
			call	lcd_time
			call	lcd_posdown
;test klavesnice 
menu_sweep4_1:																	
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_sweep4_sec
			sbrs	r16,enter			;Enter
			rjmp	menu_sweep5
			sbrs	r16,incre			;INC
			rjmp	menu_sweep4_inc
			sbrs	r16,decre			;DEC
			rjmp	menu_sweep4_dec
			sbrs	r16,esc				;ESC
			rjmp	menu_sweep4_end		
			rjmp	menu_sweep4_1
menu_sweep4_end:
			call	freq3_freq
			rjmp	menu_sweep3_after
;zmena z ms na sec
menu_sweep4_sec:
			lds		r16,hz
			inc		r16
			cpi		r16,3
			brmi	menu_sweep4_sec1
			ldi		r16,1
menu_sweep4_sec1:
			sts		hz,r16
			call	waitnokeyp
			rjmp	menu_sweep4_2

; pricitani frekvence
menu_sweep4_inc:
			ldi		r17,1
			clr		r18
			lds		r16,hz
			cpi		r16,1
			breq	menu_sweep4_inc1
			ldi		r17,100
menu_sweep4_inc1:
			lds		zl,time1
			lds		zh,time2
			add		zl,r17
			adc		zh,r18
			ldi		r17,high(5990)
			ldi		r16,low(5990)
			sub		r16,zl
			sbc		r17,zh
			brcs	menu_sweep4_common1
menu_sweep4_common:
			sts		time1,zl
			sts		time2,zh
menu_sweep4_common1:
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	menu_sweep4_2
;odecitani casu
menu_sweep4_dec:
			ldi		r17,1
			clr		r18
			lds		r16,hz
			cpi		r16,1
			breq	menu_sweep4_dec1
			ldi		r17,100
menu_sweep4_dec1:
			lds		zl,time1
			lds		zh,time2
			sub		zl,r17
			sbc		zh,r18
			brcs	menu_sweep4_common1
			tst		zl
			brne	menu_sweep4_common
			tst		zh
			brne	menu_sweep4_common
			rjmp	menu_sweep4_common1
			
menu_sweep5:
; Zobrazeni uvodni frekvence
			call	freq1_freq
			clr		r16
			sts		menus1,r16

			call	check_hz
			call	lcd_freq_view
			ldi		r16,$FF
			sts		start,r16
			call	stop_time
menu_sweep5_1:
			lds		r16,keyb
			cpi		r16,0b00100100
			breq	menu_sweep5_preview
			sbrs	r16,enter			;Enter
			rjmp	menu_sweep5_stop_start
			sbrs	r16,esc				;ESC
			rjmp	menu_sweep5_end		
			rjmp	menu_sweep5_1
menu_sweep5_preview:
			clr		r16
			sts		menus1,r16
			sts		start,r16
			call	freq_none			;nebezi zadna frekvence
			call	spi_freq
			rjmp	menu_sweep4_after
menu_sweep5_stop_start:
			lds		r16,menus1
			tst		r16
			breq	menu_sweep5_stop_start_1
			clr		r16
			sts		menus1,r16
			sts		start,r16
			call	freq_none			;nebezi zadna frekvence
			call	spi_freq
			call	waitnokeyp
			rjmp	menu_sweep5
menu_sweep5_stop_start_1:
			ldi		r16,$FF
			sts		menus1,r16

			clr		r16
			sts		ms1,r16
			sts		ms2,r16
			sts		ms_temp,r16
			call	waitnokeyp
			rjmp	menu_sweep5_1
menu_sweep5_end:
			clr		r16
			sts		menus1,r16
			call	freq_none			;nebezi zadna frekvence
			call	waitnokeyp
			rjmp	menu
; *************************************************
; Preruseni po 5ms
timer1overflow:	
; *************************************************
; Ulozeni vsech rozpracovanych registru
			push	r0
			push	r1
			push	r2
			push	r3
			push	r4
			push	r5
			push	r6
			push	r7
			push	r8
			push	r9
			push	r10
			push	r31
			push	r30
			push	r29
			push	r28
			push	r27
			push	r26
			push	r25
			push	r24
			push	r23
			push	r22
			push	r21
			push	r20
			push	r19
			push 	r18
			push	r17
			push	r16
			in		r16,sreg
			push	r16
; *************************************************
; nastaveni casu na 5ms
			ldi		r16,high(caskalibr)					;
			out		tcnt1h,r16							;
			ldi		r16,low(caskalibr)					;
			out		tcnt1l,r16							;nastaveni na 5ms CASovac
; *************************************************
;pricitani po 0.005 sec
			lds		r16,keyb_speed
			inc		r16
			cpi		r16,2
			brne	ms_005a
			clr		r16
ms_005a:
			sts		keyb_speed,r16
			lds		r16,ms_temp
			inc		r16
			cpi		r16,2
			breq	ms_10
			sts		ms_temp,r16
			rjmp	ms_005
ms_10:
			
; *************************************************
;uz je 0.1sec tak pricitani
			clr		r16
			sts		ms_temp,r16
			lds		xl,ms1
			lds		xh,ms2
			adiw	xh:xl,1
			sts		ms2,xh
			sts		ms1,xl
			call	stop_time
; *************************************************
;zde se deje vse po 5ms			
ms_005:
; *************************************************
; Test klavesnice
			lds		r16,keyb_speed
			cpi		r16,1
			breq	ms_006
			rjmp	timeroverflow_keyb_end
ms_006:
			in		r16,pinb
			andi	r16,0b00111100
			cpi		r16,0b00111100
			breq	timeroverflow_keyb1
			lds		r17,keyb_temp
			cp		r16,r17							
			breq	timeroverflow_keyb2					;je stisknuta ta sama klavesa
			sts		keyb_temp,r16
			sts		keyb,r16
			sbrs	r16,incre
			rjmp	timeroverflow_keyb11
			sbrs	r16,decre
			rjmp	timeroverflow_keyb11
			rjmp	timeroverflow_keyb4
timeroverflow_keyb11:
			andi	r16,0b00011000
			cpi		r16,0b00000000
			breq	timeroverflow_keyb4
			ldi		r16,0b00111100
			sts		keyb,r17
			ldi		r16,$f8
			sts		keyb_repeat_temp,r16
			rjmp	timeroverflow_keyb_end
timeroverflow_keyb2:
; *************************************************
; je stisknuta ta sama klavesa, kdyz ESC nebo Enter tak keyb jako kdyz nic neni stisknuto
			sbrs	r16,2
			rjmp	timeroverflow_keyb7					;je stisknut Esc nebo Enter
			sbrs	r16,5
			rjmp	timeroverflow_keyb7					;je stisknut Esc nebo Enter
			cpi		r16,0b00100100
			breq	timeroverflow_keyb7		`			;je stisknuta soucasne INC + DEC

; *************************************************
; tady zacne pusobit autorepeat je stisknuta INC nebo DEC
timeroverflow_keyb3:
			lds		r17,keyb_repeat_temp
			inc		r17
			lds		r18,keyb_repeat
			cp		r17,r18
			breq	timeroverflow_keyb5					;uz je na case autorepeat
; *************************************************
;autorepeat jeste nedobehnul takze se bude pricitat a keyb jako kdyz nic
			sts		keyb_repeat_temp,r17
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	timeroverflow_keyb_end
; *************************************************
;autorepeat uz je takze klavesa se muze objevit
timeroverflow_keyb5:
			clr		r17
			sts		keyb_repeat_temp,r17
			clc
			ror		r18
			cpi		r18,1
			breq	timeroverflow_keyb6					;uz je maximalni autorepeat
			sts		keyb_repeat,r18
timeroverflow_keyb6:
			sts		keyb,r16
			rjmp	timeroverflow_keyb_end
; *************************************************
; je stisknuta klavesa Enter nebo Esc stale
timeroverflow_keyb7:
			ldi		r16,0b00111100
			sts		keyb,r16
			rjmp	timeroverflow_keyb4
timeroverflow_keyb1:
; *************************************************
; nebyla stisknuta zadna klavesa
			ldi		r16,0b00111100
			sts		keyb,r16
			sts		keyb_temp,r16
			lds		r16,waitnokey
			inc		r16
			sts		waitnokey,r16
timeroverflow_keyb4:
; *************************************************
; vynulovani autorepeatu
			ldi		r16,$FF
			sts		keyb_repeat,r16
			clr		r16
			sts		keyb_repeat_temp,r16

timeroverflow_keyb_end:



timer1overflow_end:
; *************************************************
; nacteni puvodnich hodnot registru vcetne priznaku
			pop		r16
			out		sreg,r16
			pop		r16
			pop		r17
			pop		r18
			pop		r19
			pop		r20
			pop		r21
			pop		r22
			pop		r23
			pop		r24
			pop		r25
			pop		r26
			pop		r27
			pop		r28
			pop		r29
			pop		r30
			pop		r31
			pop		r10
			pop		r9
			pop		r8
			pop		r7
			pop		r6
			pop		r5
			pop		r4
			pop		r3
			pop		r2
			pop		r1
			pop		r0
			reti



zobr_cislo:
			call	bintoasca
			mov		r16,r21
			call	lcd_char
			mov		r16,r22
			call	lcd_char
			mov		r16,r23
			call	lcd_char
			mov		r16,r24
			call	lcd_char
			mov		r16,r25
			call	lcd_char
			ret 
 

.include "lcd.asm"			
.include "spi.asm"
.include "other.asm"
.include "text.asm"