; display je zapojen na
; PORTC.4   - RS 
; PORTC.5	- E
; PORTC.0	- DB4
; PORTC.1	- DB5
; PORTC.2	- DB6
; PORTC.3	- DB7
;****************************************************************************
; Inicializace Displaye 
;----------------------------------------------------------------------------
; Vstupni parametry
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry R18,R16
;............................................................................
lcdinit:   
			ldi		r18,50
lcdinit_1: 	
			call	delay5ms
           	dec		r18
           	brne	lcdinit_1
           	ldi 	r16,0b00110000        			;musi se to trikrat poslat
           	out 	portc, r16             
           	call 	lcd_enable             			;1
           	call 	delay5ms
           	call 	lcd_enable             			;2
           	call 	delay5ms
           	call 	lcd_enable             			;a po 3!
           	call 	delay5ms
           	ldi 	r16, 0b00100000        			;4bit mod zapnuti
           	out 	portc, r16						;poslani dat na port C
           	call 	lcd_enable						;;odeslani prikazu na display
           	call 	delay5ms
           	ldi 	r16, 0b00101100        			;4bit-Mod zapnut + 16x2 znaky display
           	call 	lcd_cmd							;odeslani prikazu na display
           	ldi 	r16, 0b00001100        			;zapnuti displaye,kurzor vypnuty a ani neblika
           	call 	lcd_cmd							;odeslani prikazu na display
           	ldi 	r16, 0b00000110        			;posuv kurzoru vpravo
           	call 	lcd_cmd							;odeslani prikazu na display
           	ret
;****************************************************************************
;poslani znaku na display
;----------------------------------------------------------------------------
; Vstupni parametry
; R16 - znak zobrazeny na display
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry R17,R16
;............................................................................
lcd_char:
           	mov 	r17, r16             			;zaloha znaku do registru R17 
			swap	r16
           	andi 	r16, 0b00001111       			;v R16 zbude jen horni cast bytu
           	out 	portc, r16             			;poslani na port C
           	sbi		portc, 4						;nastaveni RS na log. 1 pro zapis znaku
		   	call 	lcd_enable             			;poslani dat na display
           	andi 	r17, 0b00001111       			;v R17 zbude jen horni cast bytu
           	out 	portc, r17             			;poslani na port C
		   	sbi		portc,4							;nastaveni RS na log. 1 pro zapis znaku
           	call 	lcd_enable             			;poslani dat na display
           	call 	delay50us              			;zpozdeni 50uS
           	ret                          			
;****************************************************************************
;poslani prikazu na display
;----------------------------------------------------------------------------
; Vstupni parametry
; R16 - prikaz
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry R17,R16
;............................................................................
lcd_cmd:                            
	       	mov 	r17, r16             			;zaloha znaku do registru R17 
			swap	r16
           	andi 	r16, 0b00001111       			;v R16 zbude jen horni cast bytu
           	out 	portc, r16             			;poslani na port C
		   	call 	lcd_enable             			;poslani dat na display
		   	
           	andi 	r17, 0b00001111       			;v R17 zbude jen horni cast bytu
           	out 	portc, r17             			;poslani na port C
           	call 	lcd_enable             			;poslani dat na display
           	call 	delay50us              			;zpozdeni 50uS
           	ret
;****************************************************************************
;potvrzeni dat pro display
;----------------------------------------------------------------------------
; Vstupni parametry
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry 
;............................................................................
lcd_enable:
			sbi 	PORTC, 5                 		;Enable bit zapnut
           	nop                          			;3 Takty cekani
           	nop
           	nop
           	cbi 	PORTC, 5                 		;Enable bit vypnut
           	ret                                               
;****************************************************************************
;Smazani displaye a navrat do vychozi pozice (vlevo nahore)
;----------------------------------------------------------------------------
; Vstupni parametry
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry 
;............................................................................
lcdcls:    
			ldi 	r16, 0b00000001  	 			;prikaz pro vymaz displaye
           	call 	lcd_cmd							;poslani prikazu
           	call 	delay5ms						;zpozdeni 5ms
           	call 	delay5ms						;zpozdeni 5ms
           	call 	delay5ms						;zpozdeni 5ms
           	call 	delay5ms						;zpozdeni 5ms

           	ret

;****************************************************************************
;Skok na urcitou pozici na display (0..15 prvni radek 16..31 druhy radek)
;----------------------------------------------------------------------------
; Vstupni parametry R16
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry R16,R17
;............................................................................

lcd_pos:    
			mov 	r17,r16			  	 			;zaloha R17=R16
			ldi		r18,15
			sub		r18,r16
           	brpl	lcd_pos1						;pozice je na prvnim radku skok
			ldi		r16,47							;konstanta pro druhy radek
			add		r17,r16							;pricteni konstanty 
lcd_pos1:
			mov		r16,r17							;presun R16=R17		
			ori		r16,0b10000000					;nastaveni priznaku pro zapis adresy
			call 	lcd_cmd							;poslani prikazu
           	call 	delay5ms						;zpozdeni 5ms
           	ret
;****************************************************************************
;Skok na prvni radek
;----------------------------------------------------------------------------
; Vstupni parametry R16
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry 
;............................................................................
lcd_posup:
			ldi		r16,0							;pozice prvniho radku
			rjmp	lcd_pos
;****************************************************************************
;Skok na druhy radek
;----------------------------------------------------------------------------
; Vstupni parametry R16
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry 
;............................................................................
lcd_posdown:
			ldi		r16,16
			rjmp	lcd_pos							;pozice druheho radku
;****************************************************************************
;Napsani textu definovaneho v DB ktery je dlouhy 16znaku a 17znak je 0x00
;----------------------------------------------------------------------------
; Vstupni parametry ZH,ZL
;			ldi		ZH,high(2*znakh)				
;			ldi		ZL,low(2*znakl)
;............................................................................
; Vystupni parametry
;............................................................................
; pozite registry ZH,ZL,R0
;............................................................................
lcd_text:	
			ldi		r18,9
lcd_text2:
			lpm										;nacteni do R0 znak definovany ZH,ZL
			subi	r18,1
			tst		r18								;testovani zda R0 = 0
			breq	lcd_text1						;R0=0 uz je konec skok 
			mov		r16,r0							;presun R0 do R16 pro zobrazeni na display
			call	lcd_char						;zobrazeni znaku
	        adiw	ZH:ZL,1							;posun o dalsi znak
			rjmp	lcd_text2						;opakovani smycky
lcd_text1:
			ret

;****************************************************************************
; dolni radka prazdna
lcd_down_freq:
			call	lcd_posdown
			ldi		ZH,high(2*t_freq)				
			ldi		ZL,low(2*t_freq)	
			call	lcd_text
			ret
;****************************************************************************
;zobrazeni frekvence + jednotek
lcd_freq:
			call	lcd_freq_view
			call	lcd_posdown
			lds		r16,hz
			cpi		r16,1
			breq	lcd_freq_mHz
			cpi		r16,2
			breq	lcd_freq_Hz
			cpi		r16,3
			breq	lcd_freq_kHz
			ldi		ZH,high(2*t_MHz)				
			ldi		ZL,low(2*t_MHz)	
			call	lcd_text
			ret
lcd_freq_mHz:
			ldi		ZH,high(2*t_miHz)				
			ldi		ZL,low(2*t_miHz)	
			call	lcd_text
			ret
lcd_freq_Hz:
			ldi		ZH,high(2*t_Hz)				
			ldi		ZL,low(2*t_Hz)	
			call	lcd_text
			ret
lcd_freq_kHz:
			ldi		ZH,high(2*t_kHz)				
			ldi		ZL,low(2*t_kHz)	
			call	lcd_text
			ret
;****************************************************************************
;zobrazeni frekvence na prvni radce
lcd_freq_view:
			call	lcd_posup
			lds		r19,freq4
			lds		r18,freq3
			lds		r17,freq2
			lds		r16,freq1
			call	bintoasc
			lds		r16,hz
			cpi		r16,1
			breq	lcd_freq1						;maji byt zobrazeny mHz
			lds		r16,c1000000000
			call	lcd_char
			lds		r16,c100000000
			call	lcd_char
			lds		r16,c10000000
			call	lcd_char
lcd_freq1:
			lds		r16,c1000000
			call	lcd_char
			lds		r16,c100000
			call	lcd_char
			lds		r16,c10000
			call	lcd_char
			lds		r16,c1000
			call	lcd_char
			lds		r16,c100
			call	lcd_char
			lds		r16,hz
			cpi		r16,1
			brne	lcd_freq2						;nejsou  zobrazeny mHz
			ldi		r16,$2e
			call	lcd_char
			lds		r16,c10
			call	lcd_char
			lds		r16,c1
			call	lcd_char
lcd_freq2:
			ret
;****************************************************************************
;zobrazeni casu
lcd_time:
			ldi		ZH,high(2*t_none)				
			ldi		ZL,low(2*t_none)	
			call	lcd_text
			ldi		r16,1
			call	lcd_pos
			lds		r16,time2
			lds		r17,time1
			call	bintoasca
			mov		r16,r22
			call	lcd_char
			mov		r16,r23
			call	lcd_char
			ldi		r16,$2e
			call	lcd_char
			mov		r16,r24
			call	lcd_char
			mov		r16,r25
			call	lcd_char
			ldi		r16,48
			call	lcd_char
			call	lcd_posdown
			lds		r16,hz
			cpi		r16,1
			brne	lcd_time2
			ldi		ZH,high(2*t_time_ms)				
			ldi		ZL,low(2*t_time_ms)	
			rjmp	lcd_time3
lcd_time2:
			ldi		ZH,high(2*t_time_sec)				
			ldi		ZL,low(2*t_time_sec)	
lcd_time3:
			call	lcd_text								
			ret