;FSYNC ... Port D.4
;DATA  ... Port D.3
;CLK   ... Port D.2
; *************************************************
;Odesilani dat R17:R16 na sbernici SPI
spi_write:
			sbi		portd,4				;vynulovani SPI sbernice
			call	spi_clk
			call	spi_clk
			nop
			nop
			ldi		r18,8
spi_write2:
			cbi		portd,4				;FSYNC = 0 tj. start
			clc
			cbi		portd,3
			rol		r17
			brcc	spi_write1
			sbi		portd,3
spi_write1:
			call	spi_clk
			dec		r18
			brne	spi_write2
			ldi		r18,8
spi_write4:
			cbi		portd,4				;FSYNC = 0 tj. start
			clc
			cbi		portd,3
			rol		r16
			brcc	spi_write3
			sbi		portd,3
spi_write3:
			call	spi_clk
			dec		r18
			brne	spi_write4
			sbi		portd,4				;FSYNC =1 tj. stop
			call	spi_clk
			call	spi_clk
			ret

spi_clk:	sbi		portd,2
			cbi		portd,2
			nop
			nop
			nop
			sbi		portd,2
			ret
; *************************************************
;Inicializace AD9835
spi_ini:
			clr		r16
			ldi		r17,0b11011000
			call	spi_write
			clr		r16
			ldi		r17,0b10000000
			call	spi_write
			call	spi_freq
			ldi		r17,0b11000000
			call	spi_write
			ret
; *************************************************
;odeslani frekvence AD1:AD4 na SPI sbernici 
spi_freq:
			lds		r16,ad1
			ldi		r17,0b00100011
			call	spi_write
			lds		r16,ad2
			ldi		r17,0b00100010
			call	spi_write
			lds		r16,ad3
			ldi		r17,0b00100001
			call	spi_write
			lds		r16,ad4
			ldi		r17,0b00100000
			call	spi_write
			clr		r16
			ret
; *************************************************
;INIcializace AD9835 s frekvenci 0Hz
freq_none:
			clr		r16
			sts		freq1,r16
			sts		freq2,r16
			sts		freq3,r16
			sts		freq4,r16
			call	spi_ini
			clr		r16
			ldi		r17,0b11111000
			call	spi_write
			ret
; *************************************************
